/***************************************************************************
                          sqlguiview.h  -  description
                             -------------------
    begin                : Sat Apr 14 18:28:06 CEST 2001
    copyright            : (C) 2001 by mb
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SQLGUIVIEW_H
#define SQLGUIVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for Qt
#include <qwidget.h>
#include <qvariant.h>
#include <ktoolbar.h>
#include <qsplitter.h>
#include <qfiledialog.h>

#ifndef EXPORT_FORMATE_H
#include <export_formate.h>
#endif

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout;
class QComboBox;
class QFrame;
class QListView;
class QListViewItem;
class QMultiLineEdit;
class QPushButton;
class QTable;

class SqlGuiDoc;

/** The SqlGuiView class provides the view widget for the SqlGuiApp instance.	
 * The View instance inherits QWidget as a base class and represents the view object of a KTMainWindow. As SqlGuiView is part of the
 * docuement-view model, it needs a reference to the document object connected with it by the SqlGuiApp class to manipulate and display
 * the document structure provided by the SqlGuiDoc class.
 * 	
 * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team.
 * @version KDevelop version 0.4 code generation
 */
class SqlGuiView : public QWidget
{
  Q_OBJECT
  public:
    /** Constructor for the main view */
    SqlGuiView(QWidget *parent = 0, const char *name=0);
    /** Destructor for the main view */
    ~SqlGuiView();

    QString* selectedDB();
    QString* selectedTable();

    QFrame* Kasten;
    QTable* ResultList;
    QListView* DATABASES;
    QMultiLineEdit* sqlEdit;
    QPushButton* sqlEditClear;
    QPushButton* sqlSubmit;
    QComboBox* sqlHistory;
//    QFrame* Line1;
    QSplitter* Line1;

    /** returns a pointer to the document connected to the view instance. Mind that this method requires a SqlGuiApp instance as a parent
     * widget to get to the window document pointer by calling the SqlGuiApp::getDocument() method.
     *
     * @see SqlGuiApp#getDocument
     */
    SqlGuiDoc *getDocument() const;
    void deleteBase();
    void deleteTable();

    /** contains the implementation for printing functionality */
    void print(QPrinter *pPrinter);

    public slots: 
    void slotUpdateMainView();	
    void slotUpdateResultList();
    void slotDeleteBase();
    void slotDeleteTable();
		void slotExport();

    private slots:
    void slotEditorQuery();
    void slotEditorAddHistory();
    void slotDoubleClickQuery(QListViewItem * item);
    void slotDbMenu( QListViewItem* item, const QPoint & pos, int num );
    void slotCreateDB();
    void slotCreateTable();
    void slotCheckTable();
    void slotOptimizeTable();
    void slotRepairTable();
    void slotUpdateTable(int row, int col);
		void slotUpdateLastAction(QString* db, QString* tab, QString* prim);
		void slotConfirmOverwrite(const QString & filename);
/*		
		void slotExportDB(QString* db, int format);
		void slotExportTable(QString* db, QString* tb, int format);
		void slotExportSelection( int row1, int col1, int row2, int col2, int format);
*/
    void slotExportDlg(int what, int form);
		void slotExportDlg2();
		void slotSetExport(int what, int form);
		void slotSelectExport( const QString & expfile);
		void qtsuxx( const QString & expfile );

 signals:
    void doQuery( QString * Base, QString * Query );
    void createDb();
    void deleteDb( QString* );
    void createTable();
    void deleteTable( QString* db, QString* tb );
    void checkTable( QString* db, QString* tb );
    void optimizeTable( QString* db, QString* tb );
    void repairTable( QString* db, QString* tb );
    void gotResult();
    void overwrite(const QString & filename);
    void donotoverwrite(const QString & filename);

  private:
		QFileDialog* whatfile2;
		QString* lastActionDB;
		QString* lastActionTab;
		QString* lastActionPrim;
		int exportdata;
		int exportform;
  
  void resizeEvent( QResizeEvent * );
};

#endif // SQLGUIVIEW_H
